<?php

class Andy_WeeklyDigest_CronEntry_WeeklyDigest
{
	public static function runWeeklyDigest()
	{						
		// calculate dateline
		$dateline = time() - (86400 * 7);	
		
		//########################################
		// exclude forums
		//########################################	
		
		// define variable;
		$whereclause1 = '';			
		
		// get options from Admin CP -> Options -> Weekly Digest -> Exclude Forums
		$excludeForums = XenForo_Application::get('options')->weeklyDigestExcludeForums;
		
		if ($excludeForums != '')
		{
			// remove trailing comma
			$excludeForums = rtrim($excludeForums, ',');				
			
			$nodeIds = explode(',', $excludeForums);		
			
			// create whereclause1 of excluded forums
			$whereclause1 = 'AND (xf_thread.node_id <> ' . implode(' AND xf_thread.node_id <> ', $nodeIds);
			$whereclause1 = $whereclause1 . ')';
		}	
		
		//########################################
		// get threads
		//########################################
		
		// get options from Admin CP -> Options -> Weekly Digest -> Limit
		$limit = XenForo_Application::get('options')->weeklyDigestLimit;		
		
		// get database
		$db = XenForo_Application::get('db');			
		
		// run query
		$threads = $db->fetchAll("
		SELECT xf_thread.title, thread_id, xf_node.title AS forumTitle
		FROM xf_thread
		INNER JOIN xf_node ON xf_node.node_id = xf_thread.node_id
		WHERE xf_thread.post_date > " . $dateline . "
		AND xf_thread.discussion_state = 'visible'
		$whereclause1
		ORDER BY forumTitle ASC, xf_thread.view_count DESC
		LIMIT ?
		", $limit);	
		
		//########################################
		// test userId
		//########################################	
		
		// define variable;
		$whereclause2 = '';			
		
		// get options from Admin CP -> Options -> Weekly Digest -> Exclude Forums
		$testUserId = XenForo_Application::get('options')->weeklyDigestTestUserId;	
		
		if ($testUserId != '')
		{
			$whereclause2 = 'AND user_id = ' . $testUserId;
		}					
		
		//########################################
		// get emails
		//########################################
		
		// calculate dateline
		$dateline = time() - (86400 * 30);											
		
		// run query
		$emails = $db->fetchAll("
		SELECT username, email
		FROM xf_user
		WHERE last_activity > " . $dateline . "
		AND user_state = 'valid'
		AND is_banned = 0
		AND weekly_digest_opt_out = 0
		$whereclause2
		");	
	
		//########################################
		// start message
		//########################################
		
		// get options from Admin CP -> Options -> Basic Board Information -> Board Title
		$boardTitle = XenForo_Application::get('options')->boardTitle;	
		
		// get subject
		$subject = new XenForo_Phrase('weeklydigest_subject');
		
		// get forumPhrase
		$forumPhrase = new XenForo_Phrase('weeklydigest_forum');
		
		// get titlePhrase
		$titlePhrase = new XenForo_Phrase('weeklydigest_title');
		
		// start table
		$message = '
<table cellspacing="5">
<tr>
<th align="left">' . $forumPhrase . '</th>
<th align="left">' . $titlePhrase . '</th>
';	
		// foreach threads
		foreach ($threads as $thread)
		{
			// build link
			$link = XenForo_Link::buildPublicLink('threads', $thread);
			
			// message details
			$message .= '<tr><td>' . $thread['forumTitle'] . '</td>';
			$message .= '<td>' . '<a href="' . $link . '">' . $thread['title'] . '</a></td></tr>';
		}
		
		// end table
		$message .= '</tr></table>';
		
		//########################################
		// add unsubscribe and forgot password
		//########################################

		// message
		$message .= '<br /><br />' . new XenForo_Phrase('weeklydigest_unsubscribe_link');
		
		// create unsubscribeLink
		$unsubscribeLink = XenForo_Link::buildPublicLink('weeklydigest/manage/');
		
		// add unsubscribeLink to message
		$message = str_replace('{unsubscribe_link}', $unsubscribeLink, $message);	
		
		//########################################
		// replace {board_title} in message
		//########################################		
		
		$message = str_replace('{board_title}', $boardTitle, $message);			

		//########################################
		// send email
		//########################################
		
		// set to zero, no PHP time limit is imposed
		set_time_limit(0);

		// foreach emails
		foreach ($emails as $k => $v)
		{	
			// prepare $to variable
			$to = $v['email'];			

			// username
			$username = $v['username'];
			
			// email 
			$email = $v['email'];
			
			// define user variable
			$user = array(
				'username' => $username,
				'email' => $email
			);
			
			// prepare mailParams                    
			$mailParams = array(
				'user' => $user,
				'subject' => $subject,
				'message' => $message
			);
				
			// prepare mail variable
			$mail = XenForo_Mail::create('weeklydigest_contact', $mailParams);
			
			// send mail
			$mail->queue($user['email'], $user['username']);
		}
	}
}